01d0ceedfc593f6d3a8bc4b0fae2d743b090cc44
[git-central.git] / tests / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
8
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
40 GIT_MERGE_VERBOSITY=5
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
44 export EDITOR VISUAL
45 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
46
47 # Protect ourselves from common misconfiguration to export
48 # CDPATH into the environment
49 unset CDPATH
50
51 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52         1|2|true)
53                 echo "* warning: Some tests will not work if GIT_TRACE" \
54                         "is set as to trace on STDERR ! *"
55                 echo "* warning: Please set GIT_TRACE to something" \
56                         "other than 1, 2 or true ! *"
57                 ;;
58 esac
59
60 # Each test should start with something like this, after copyright notices:
61 #
62 # test_description='Description of this test...
63 # This test checks if command xyzzy does the right thing...
64 # '
65 # . ./test-lib.sh
66 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
67                 TERM=$ORIGINAL_TERM &&
68                 export TERM &&
69                 [ -t 1 ] &&
70                 tput bold >/dev/null 2>&1 &&
71                 tput setaf 1 >/dev/null 2>&1 &&
72                 tput sgr0 >/dev/null 2>&1
73         ) &&
74         color=t
75
76 while test "$#" -ne 0
77 do
78         case "$1" in
79         -d|--d|--de|--deb|--debu|--debug)
80                 debug=t; shift ;;
81         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82                 immediate=t; shift ;;
83         -h|--h|--he|--hel|--help)
84                 help=t; shift ;;
85         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
86                 verbose=t; shift ;;
87         -q|--q|--qu|--qui|--quie|--quiet)
88                 quiet=t; shift ;;
89         --no-color)
90                 color=; shift ;;
91         --no-python)
92                 # noop now...
93                 shift ;;
94         *)
95                 break ;;
96         esac
97 done
98
99 if test -n "$color"; then
100         say_color () {
101                 (
102                 TERM=$ORIGINAL_TERM
103                 export TERM
104                 case "$1" in
105                         error) tput bold; tput setaf 1;; # bold red
106                         skip)  tput bold; tput setaf 2;; # bold green
107                         pass)  tput setaf 2;;            # green
108                         info)  tput setaf 3;;            # brown
109                         *) test -n "$quiet" && return;;
110                 esac
111                 shift
112                 echo "* $*"
113                 tput sgr0
114                 )
115         }
116 else
117         say_color() {
118                 test -z "$1" && test -n "$quiet" && return
119                 shift
120                 echo "* $*"
121         }
122 fi
123
124 error () {
125         say_color error "error: $*"
126         trap - exit
127         exit 1
128 }
129
130 say () {
131         say_color info "$*"
132 }
133
134 test "${test_description}" != "" ||
135 error "Test script did not set test_description."
136
137 if test "$help" = "t"
138 then
139         echo "$test_description"
140         exit 0
141 fi
142
143 exec 5>&1
144 if test "$verbose" = "t"
145 then
146         exec 4>&2 3>&1
147 else
148         exec 4>/dev/null 3>/dev/null
149 fi
150
151 test_failure=0
152 test_count=0
153 test_fixed=0
154 test_broken=0
155
156 die () {
157         echo >&5 "FATAL: Unexpected exit with code $?"
158         exit 1
159 }
160
161 trap 'die' exit
162
163 # The semantics of the editor variables are that of invoking
164 # sh -c "$EDITOR \"$@\"" files ...
165 #
166 # If our trash directory contains shell metacharacters, they will be
167 # interpreted if we just set $EDITOR directly, so do a little dance with
168 # environment variables to work around this.
169 #
170 # In particular, quoting isn't enough, as the path may contain the same quote
171 # that we're using.
172 test_set_editor () {
173         FAKE_EDITOR="$1"
174         export FAKE_EDITOR
175         VISUAL='"$FAKE_EDITOR"'
176         export VISUAL
177 }
178
179 test_tick () {
180         if test -z "${test_tick+set}"
181         then
182                 test_tick=1112911993
183         else
184                 test_tick=$(($test_tick + 60))
185         fi
186         GIT_COMMITTER_DATE="$test_tick -0700"
187         GIT_AUTHOR_DATE="$test_tick -0700"
188         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
189 }
190
191 # You are not expected to call test_ok_ and test_failure_ directly, use
192 # the text_expect_* functions instead.
193
194 test_ok_ () {
195         test_count=$(expr "$test_count" + 1)
196         say_color "" "  ok $test_count: $@"
197 }
198
199 test_failure_ () {
200         test_count=$(expr "$test_count" + 1)
201         test_failure=$(expr "$test_failure" + 1);
202         say_color error "FAIL $test_count: $1"
203         shift
204         echo "$@" | sed -e 's/^/        /'
205         test "$immediate" = "" || { trap - exit; exit 1; }
206 }
207
208 test_known_broken_ok_ () {
209         test_count=$(expr "$test_count" + 1)
210         test_fixed=$(($test_fixed+1))
211         say_color "" "  FIXED $test_count: $@"
212 }
213
214 test_known_broken_failure_ () {
215         test_count=$(expr "$test_count" + 1)
216         test_broken=$(($test_broken+1))
217         say_color skip "  still broken $test_count: $@"
218 }
219
220 test_debug () {
221         test "$debug" = "" || eval "$1"
222 }
223
224 test_run_ () {
225         eval >&3 2>&4 "$1"
226         eval_ret="$?"
227         return 0
228 }
229
230 test_skip () {
231         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
232         this_test="$this_test.$(expr "$test_count" + 1)"
233         to_skip=
234         for skp in $GIT_SKIP_TESTS
235         do
236                 case "$this_test" in
237                 $skp)
238                         to_skip=t
239                 esac
240         done
241         case "$to_skip" in
242         t)
243                 say_color skip >&3 "skipping test: $@"
244                 test_count=$(expr "$test_count" + 1)
245                 say_color skip "skip $test_count: $1"
246                 : true
247                 ;;
248         *)
249                 false
250                 ;;
251         esac
252 }
253
254 test_expect_failure () {
255         test "$#" = 2 ||
256         error "bug in the test script: not 2 parameters to test-expect-failure"
257         if ! test_skip "$@"
258         then
259                 say >&3 "checking known breakage: $2"
260                 test_run_ "$2"
261                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
262                 then
263                         test_known_broken_ok_ "$1"
264                 else
265                     test_known_broken_failure_ "$1"
266                 fi
267         fi
268         echo >&3 ""
269 }
270
271 test_expect_success () {
272         test "$#" = 2 ||
273         error "bug in the test script: not 2 parameters to test-expect-success"
274         test_name="$1"
275         if ! test_skip "$@"
276         then
277                 say >&3 "expecting success: $2"
278                 test_run_ "$2"
279                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
280                 then
281                         test_ok_ "$1"
282                 else
283                         test_failure_ "$@"
284                 fi
285         fi
286         echo >&3 ""
287 }
288
289 test_expect_code () {
290         test "$#" = 3 ||
291         error "bug in the test script: not 3 parameters to test-expect-code"
292         if ! test_skip "$@"
293         then
294                 say >&3 "expecting exit code $1: $3"
295                 test_run_ "$3"
296                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
297                 then
298                         test_ok_ "$2"
299                 else
300                         test_failure_ "$@"
301                 fi
302         fi
303         echo >&3 ""
304 }
305
306 # This is not among top-level (test_expect_success | test_expect_failure)
307 # but is a prefix that can be used in the test script, like:
308 #
309 #       test_expect_success 'complain and die' '
310 #           do something &&
311 #           do something else &&
312 #           test_must_fail git checkout ../outerspace
313 #       '
314 #
315 # Writing this as "! git checkout ../outerspace" is wrong, because
316 # the failure could be due to a segv.  We want a controlled failure.
317
318 test_must_fail () {
319         "$@"
320         test $? -gt 0 -a $? -le 129
321 }
322
323 # test_cmp is a helper function to compare actual and expected output.
324 # You can use it like:
325 #
326 #       test_expect_success 'foo works' '
327 #               echo expected >expected &&
328 #               foo >actual &&
329 #               test_cmp expected actual
330 #       '
331 #
332 # This could be written as either "cmp" or "diff -u", but:
333 # - cmp's output is not nearly as easy to read as diff -u
334 # - not all diff versions understand "-u"
335
336 test_cmp() {
337         $GIT_TEST_CMP "$@"
338 }
339
340 # interpolate takes the contents of one file and interpolates the
341 # given variables into it. E.g.:
342 #
343 #     interpolate sourceFile destinationFile variableNameOne variableNameTwo
344 #
345 interpolate () {
346         input_file=$1
347         output_file=$2
348         shift && shift
349         data=$(cat $input_file)
350         # Interpolate the renaming arguments
351         for name in $* ; do
352                 eval value="$"$name
353                 data="${data//\$$name/$value}"
354         done
355         echo "$data" > $output_file
356 }
357
358 # Most tests can use the created repository, but some may need to create more.
359 # Usage: test_create_repo <directory>
360 test_create_repo () {
361         test "$#" = 1 ||
362         error "bug in the test script: not 1 parameter to test-create-repo"
363         owd=`pwd`
364         repo="$1"
365         mkdir "$repo"
366         cd "$repo" || error "Cannot setup test environment"
367         "git" init >/dev/null 2>&1 ||
368         error "cannot run git init -- have you built things yet?"
369         mv .git/hooks .git/hooks-disabled
370         cd "$owd"
371 }
372
373 test_done () {
374         trap - exit
375
376         if test "$test_fixed" != 0
377         then
378                 say_color pass "fixed $test_fixed known breakage(s)"
379         fi
380         if test "$test_broken" != 0
381         then
382                 say_color error "still have $test_broken known breakage(s)"
383                 msg="remaining $(($test_count-$test_broken)) test(s)"
384         else
385                 msg="$test_count test(s)"
386         fi
387         case "$test_failure" in
388         0)
389                 # We could:
390                 # cd .. && rm -fr 'trash directory'
391                 # but that means we forbid any tests that use their own
392                 # subdirectory from calling test_done without coming back
393                 # to where they started from.
394                 # The Makefile provided will clean this test area so
395                 # we will leave things as they are.
396
397                 say_color pass "passed all $msg"
398                 exit 0 ;;
399
400         *)
401                 say_color error "failed $test_failure among $msg"
402                 exit 1 ;;
403
404         esac
405 }
406
407 # Test the binaries we have just built.  The tests are kept in
408 # t/ subdirectory and are run in 'trash directory' subdirectory.
409 PATH=$(pwd)/..:$PATH
410 unset GIT_CONFIG
411 unset GIT_CONFIG_LOCAL
412 GIT_CONFIG_NOSYSTEM=1
413 GIT_CONFIG_NOGLOBAL=1
414 export PATH GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
415
416 # Test repository
417 test="trash directory"
418 rm -fr "$test" || {
419         trap - exit
420         echo >&5 "FATAL: Cannot prepare test area"
421         exit 1
422 }
423
424 test_create_repo "$test"
425 # Use -P to resolve symlinks in our working directory so that the cwd
426 # in subprocesses like git equals our $PWD (for pathname comparisons).
427 cd -P "$test" || exit 1
428
429 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
430 for skp in $GIT_SKIP_TESTS
431 do
432         to_skip=
433         for skp in $GIT_SKIP_TESTS
434         do
435                 case "$this_test" in
436                 $skp)
437                         to_skip=t
438                 esac
439         done
440         case "$to_skip" in
441         t)
442                 say_color skip >&3 "skipping test $this_test altogether"
443                 say_color skip "skip all tests in $this_test"
444                 test_done
445         esac
446 done
447
448 TRASH_HOOKS="$(git rev-parse --git-dir)/hooks"
449 mkdir -p "$TRASH_HOOKS"
450
451 install_client_hook () {
452     cp ../../client/$1 "$TRASH_HOOKS/$2"
453     chmod +x "$TRASH_HOOKS/$2"
454 }
455
456 install_post_checkout_hook () {
457         mkdir -p ".git/hooks"
458         hook=".git/hooks/post-checkout"
459
460         echo "#!/bin/sh" >$hook
461         for ((i=1;i<=$#;i+=1)); do
462                 eval script_name="$"$i
463                 echo "../../client/$script_name \$1 \$2 \$3 &&" >>$hook
464         done
465         echo "echo >/dev/null" >>$hook
466
467         chmod +x $hook
468 }
469
470 install_server_hook () {
471         mkdir -p "server/.git/hooks"
472         cp "../../server/$1" "server/.git/hooks/$2"
473         chmod +x "server/.git/hooks/$2"
474 }
475
476 install_update_hook () {
477         mkdir -p "server/.git/hooks"
478         hook="server/.git/hooks/update"
479
480         echo "#!/bin/sh" >$hook
481         for ((i=1;i<=$#;i+=1)); do
482                 eval script_name="$"$i
483                 echo "../../../../server/$script_name \$1 \$2 \$3 &&" >>$hook
484         done
485         echo "echo >/dev/null" >>$hook
486
487         chmod +x $hook
488 }
489
490 install_post_receive_hook () {
491         mkdir -p "server/.git/hooks"
492         hook="server/.git/hooks/post-receive"
493
494         cat >$hook <<-'EOF'
495                 #!/bin/sh
496                 nl=$'\n'
497                 input=""
498                 while read newref oldref refname ; do
499                         input="$input$newref $oldref $refname$nl"
500                 done
501         EOF
502
503         for ((i=1;i<=$#;i+=1)); do
504                 eval script_name="$"$i
505                 echo "echo -n \"\$input\" | ../../../../server/$script_name" >>$hook
506         done
507
508         chmod +x $hook
509 }
510